## START: Set by rpmautospec
## (rpmautospec version 0.3.5)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%if 0%{?rhel} == 8 || 0%{?rhel} == 9
%global with_python311 1
%global with_python312 1
%else
%global with_python311 0
%global with_python312 0
%endif

%global python_wheeldir %{_datadir}/python3-wheels
%global platform_python %{__python3}

%if %{with_python311}
%global __python311 /usr/bin/python3.11
%global python311_pkgversion 311
%global python311_pkgversion2 3.11
%global python311_sitearch %{_libdir}/python3.11/site-packages
%global python311_wheeldir %{_datadir}/python3.11-wheels
%endif

%if %{with_python312}
%global __python312 /usr/bin/python3.12
%global python312_pkgversion 312
%global python312_pkgversion2 3.12
%global python312_sitearch %{_libdir}/python3.12/site-packages
%global python312_wheeldir %{_datadir}/python3.12-wheels
%endif

# Created by pyp2rpm-3.3.5
%if 0%{?rhel}
%bcond_with docs
%else
%bcond_without docs
%endif
%bcond_without tests
%bcond_without ctf

%global pypi_name drgn

# For OL7, build against Python 3. This is a no-op on more recent versions.
%define __python %{__python3}

%global _description %{expand:
drgn (pronounced "dragon") is a debugger with an emphasis on programmability.
drgn exposes the types and variables in a program for easy, expressive
scripting in Python.}

Name:           python-%{pypi_name}
Version:	0.0.30
Release:        1.0.1%{?dist}
Summary:        Programmable debugger

License:        LGPL-2.1-or-later
URL:            https://github.com/osandov/drgn
Source0:        %{pypi_name}-%{version}.tar.bz2

%if %{with ctf}
Patch1001: 1001-linux_kernel-use-symbol-lookup-for-vmemmap_populate.patch
Patch1002: 1002-Implement-CTF-type-and-object-finder-for-Linux.patch
Patch1003: 1003-tests-add-CTF-unit-tests-non-kernel.patch
Patch1004: 1004-ctf-Add-support-for-out-of-tree-modules.patch
Patch1005: 1005-cli-add-CTF-support.patch
Patch1006: 1006-orc_info-decouple-from-drgn_module.patch
Patch1007: 1007-orc_info-Add-built-in-ORC-unwinding.patch
%endif

BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  python%{python3_pkgversion}-wheel
%if 0%{?rhel} == 7
BuildRequires:  python%{python3_pkgversion}-setuptools
%else
BuildRequires:  python%{python3_pkgversion}dist(setuptools)
%endif
%if %{with_python311}
BuildRequires: python%{python311_pkgversion2}-devel
BuildRequires: python%{python311_pkgversion2}-wheel
BuildRequires: python%{python311_pkgversion2}dist(setuptools)
%endif
%if %{with_python312}
BuildRequires: python%{python312_pkgversion2}-devel
BuildRequires: python%{python312_pkgversion2}-wheel
BuildRequires: python%{python312_pkgversion2}dist(setuptools)
%endif

%if %{with docs}
BuildRequires:  sed
BuildRequires:  python%{python3_pkgversion}dist(sphinx)
BuildRequires:  python%{python3_pkgversion}-docs
%endif

%if %{with tests}
%if 0%{?rhel} == 7
BuildRequires:  python%{python3_pkgversion}-test
%else
BuildRequires:  python%{python3_pkgversion}dist(pytest)
%if %{with_python311}
BuildRequires: python%{python311_pkgversion2}dist(pytest)
%endif
%if %{with_python312}
BuildRequires: python%{python312_pkgversion2}dist(pytest)
%endif
# C unit tests are run via check, but the minimum required version
# is not available on OL7.
BuildRequires:  check-devel >= 0.10.0
%endif
%endif
BuildRequires:  gcc-c++
BuildRequires:  make
BuildRequires:  bzip2-devel
BuildRequires:  elfutils-devel
BuildRequires:  libkdumpfile-devel
BuildRequires:  zlib-devel
BuildRequires:  xz-devel
# These are needed when building from git snapshots
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  libtool
# For applying patches with git
BuildRequires:  git
%if 0%{?rhel} == 7
BuildRequires: devtoolset-12-gcc
%endif
%if %{with ctf}
%if 0%{?rhel} == 7
# Requires binutils with libctf support and static linking
BuildRequires: devtoolset-12-binutils-devel >= 2.36.1-6.0.1
%else
BuildRequires: binutils-devel
%endif
%endif

%description %{_description}

%package -n     %{pypi_name}
Summary:        %{summary}

%description -n %{pypi_name} %{_description}

%package -n     %{pypi_name}-wheel
Summary:        The %{pypi_name} wheel
%description -n %{pypi_name}-wheel
This package contains the wheel file for drgn, which allows it to be
installed into a virtual environment or as an unprivileged user.

%if %{with_python311}
%package -n     python%{python311_pkgversion2}-%{pypi_name}
Summary:        %{summary}

%description -n python%{python311_pkgversion2}-%{pypi_name} %{_description}

%package -n     python%{python311_pkgversion2}-%{pypi_name}-wheel
Summary:        The %{pypi_name} wheel for Python 3.11
%description -n python%{python311_pkgversion2}-%{pypi_name}-wheel
This package contains the wheel file for drgn, which allows it to be
installed into a virtual environment or as an unprivileged user.
%endif

%if %{with_python312}
%package -n     python%{python312_pkgversion2}-%{pypi_name}
Summary:        %{summary}

%description -n python%{python312_pkgversion2}-%{pypi_name} %{_description}

%package -n     python%{python312_pkgversion2}-%{pypi_name}-wheel
Summary:        The %{pypi_name} wheel for Python 3.12
%description -n python%{python312_pkgversion2}-%{pypi_name}-wheel
This package contains the wheel file for drgn, which allows it to be
installed into a virtual environment or as an unprivileged user.
%endif

%if %{with docs}
%package -n %{pypi_name}-doc
Summary:        %{pypi_name} documentation
BuildArch:      noarch
Requires:       python%{python3_pkgversion}-docs

%description -n %{pypi_name}-doc %{_description}

This package contains additional documentation for %{pypi_name}.
%endif

%prep
%setup -q -n %{pypi_name}-%{version}
# Use git to apply binary patches
git init
git config user.email "build"
git config user.name "build"
git add .
git commit -a -q -m "baseline"
# Apply all the patches on top.
git am %{patches}
rm -rf .git

# Drgn has several generated source files, and the tarball contains
# pre-generated versions. However, downstream patches will modify the source
# files without the build system regenerating them. So, be sure to delete all
# possible generated source files to ensure they are regenerated.
rm -f libdrgn/*.inc
rm -f libdrgn/python/docstrings.c
rm -f libdrgn/python/docstrings.h
rm -rf build
# Remove bundled egg-info
rm -rf %{pypi_name}.egg-info
%if %{with docs}
# Use local intersphinx inventory
sed -r \
    -e 's|https://docs.python.org/3|%{_docdir}/python3-docs/html|' \
    -i docs/conf.py
%endif
# Ensure version is always set, even when building from git snapshots
if [ ! -f drgn/internal/version.py ]; then
  echo '__version__ = "%{version}"' > drgn/internal/version.py
fi

%build
%if 0%{?rhel} == 7
source /opt/rh/devtoolset-12/enable
%endif
gcc --version

V=1 %py3_build
V=1 %py3_build_wheel

# Build the alternative versions by reusing the python macros, so we have to
# redefine __python3 and reset it at the end. This will ensure that we respect
# all the build flags and other customizations provided by the RPM macros.
%if %{with_python311}
%global __python3 %{__python311}
V=1 %py3_build
V=1 %py3_build_wheel
%endif
%if %{with_python312}
%global __python3 %{__python312}
V=1 %py3_build
V=1 %py3_build_wheel
%endif
%global __python3 %{platform_python}

%if %{with docs}
# generate html docs
PYTHONPATH=${PWD} sphinx-build-3 docs html
# remove the sphinx-build leftovers
rm -rf html/.{doctrees,buildinfo}
%endif

%install
# Run the install for the additional packages first! This ensures that the
# platform python version of drgn will be the last one installed to /usr/bin.
# The additional python versions can only be used via python3.xx -m drgn; they
# have no binary installed to /usr/bin.
%if %{with_python311}
%global __python3 %{__python311}
%py3_install
install -m644 -D -t %{buildroot}%{python311_wheeldir}/ dist/%{pypi_name}*cp%{python311_pkgversion}*.whl
%endif
%if %{with_python312}
%global __python3 %{__python312}
%py3_install
install -m644 -D -t %{buildroot}%{python312_wheeldir}/ dist/%{pypi_name}*cp%{python312_pkgversion}*.whl
%endif
%global __python3 %{platform_python}
%py3_install
mkdir -p %{buildroot}%{_datadir}/drgn
cp -PR contrib tools %{buildroot}%{_datadir}/drgn
# OL7 "install -D -t" doesn't create the target directory.
mkdir -p %{buildroot}%{python_wheeldir}/
install -m644 -D -t %{buildroot}%{python_wheeldir}/ dist/%{pypi_name}*cp%{python3_version_nodots}*.whl

%if %{with tests} && 0%{?rhel} > 7
# Tests cannot pass on OL7 because check-devel is below the minimum required
# version.
%check
%{__python} setup.py test
%if %{with_python311}
V=1 %{__python311} setup.py test
%endif
%if %{with_python312}
V=1 %{__python312} setup.py test
%endif
%endif

%files -n %{pypi_name}
%license COPYING
%license LICENSES
%doc README.rst
%{_bindir}/drgn
%{_datadir}/drgn
%{python3_sitearch}/_%{pypi_name}.pyi
%{python3_sitearch}/_%{pypi_name}.cpython*.so
%{python3_sitearch}/%{pypi_name}
%{python3_sitearch}/_drgn_util
%{python3_sitearch}/%{pypi_name}-%{version}-py%{python3_version}.egg-info

%if %{with docs}
%files -n %{pypi_name}-doc
%license COPYING
%license LICENSES
%doc html
%endif

%files -n %{pypi_name}-wheel
%{python_wheeldir}/%{pypi_name}*.whl

%if %{with_python311}
%files -n python%{python311_pkgversion2}-%{pypi_name}
%license COPYING
%license LICENSES
%{python311_sitearch}/_%{pypi_name}.pyi
%{python311_sitearch}/_%{pypi_name}.cpython*.so
%{python311_sitearch}/%{pypi_name}
%{python311_sitearch}/_drgn_util
%{python311_sitearch}/%{pypi_name}-%{version}-py%{python311_pkgversion2}.egg-info

%files -n python%{python311_pkgversion2}-%{pypi_name}-wheel
%{python311_wheeldir}/%{pypi_name}*.whl
%endif

%if %{with_python312}
%files -n python%{python312_pkgversion2}-%{pypi_name}
%license COPYING
%license LICENSES
%{python312_sitearch}/_%{pypi_name}.pyi
%{python312_sitearch}/_%{pypi_name}.cpython*.so
%{python312_sitearch}/%{pypi_name}
%{python312_sitearch}/_drgn_util
%{python312_sitearch}/%{pypi_name}-%{version}-py%{python312_pkgversion2}.egg-info

%files -n python%{python312_pkgversion2}-%{pypi_name}-wheel
%{python312_wheeldir}/%{pypi_name}*.whl
%endif

%changelog
* Wed Dec 18 2024 Stephen Brennan <stephen.s.brennan@oracle.com> - 0.0.30-1.0.1
- Rebase Oracle patches on 0.0.30

* Wed Dec 18 2024 EL Errata <el-errata_ww@oracle.com> 0.0.30-1
- Update to 0.0.30

* Thu Oct 31 2024 Stephen Brennan <stephen.s.brennan@oracle.com> - 0.0.29-1.0.1
- Rebase Oracle patches on 0.0.29
- Enable builds for python 3.11 & 3.12 channels [Orabug: 37229451]

* Mon Jul 08 2024 Stephen Brennan <stephen.s.brennan@oracle.com> - 0.0.27-1.0.1
- Rebase Oracle patches on 0.0.27
- Add drgn-wheel subpackage to contain the wheel file produced during build

* Mon Jul 01 2024 EL Errata <el-errata_ww@oracle.com> 0.0.27-1
- Update to 0.0.27

* Wed Apr 17 2024 Stephen Brennan <stephen.s.brennan@oracle.com> - 0.0.26-1.0.1
- Update to 0.0.26 and rebase CTF, kallsyms, and ORC support

* Tue Mar 05 2024 Stephen Brennan <stephen.s.brennan@oracle.com> - 0.0.25-1.0.2
- Add support for debugging with Compact Type Format (CTF), built-in kallsyms, and ORC

* Fri Dec 15 2023 EL Errata <el-errata_ww@oracle.com> - 0.0.25-1.0.1
- Update to 0.0.25

* Wed Sep 13 2023 Sushmita Bhattacharya <sushmita.bhattacharya@oracle.com> - 0.0.24-1.0.1
- Removed %{autorelease} from specfile

* Fri Sep 08 2023 Omar Sandoval <osandov@osandov.com> - 0.0.24-1
- Update to 0.0.24; Fixes: RHBZ#2238043

* Fri Jul 21 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.0.23-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Thu Jul 13 2023 Davide Cavalca <dcavalca@fedoraproject.org> - 0.0.23-2
- Rebuilt for Python 3.12; Fixes: RHBZ#2220199

* Wed Jun 28 2023 Omar Sandoval <osandov@osandov.com> - 0.0.23-1
- Update to 0.0.23; Fixes: RHBZ#2218383

* Wed Jun 14 2023 Python Maint <python-maint@redhat.com> - 0.0.22-3
- Rebuilt for Python 3.12

* Fri Jan 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.0.22-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Fri Jan 06 2023 Omar Sandoval <osandov@osandov.com> - 0.0.22-1
- Update to 0.0.22

* Wed Oct 12 2022 Davide Cavalca <dcavalca@fedoraproject.org> - 0.0.21-1
- Update to 0.0.21; Fixes: RHBZ#2134210

* Sat Aug 06 2022 Michel Alexandre Salim <michel@michel-slm.name> - 0.0.20-2
- Rebuilt for libkdumpfile.so.10

* Tue Jul 26 2022 Davide Cavalca <dcavalca@fedoraproject.org> - 0.0.20-1
- Update to 0.0.20; Fixes: RHBZ#2110808

* Fri Jul 22 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.0.19-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Mon Jun 13 2022 Python Maint <python-maint@redhat.com> - 0.0.19-2
- Rebuilt for Python 3.11

* Wed May 18 2022 Davide Cavalca <dcavalca@fedoraproject.org> - 0.0.19-1
- Update to 0.0.19; Fixes: RHBZ#2088180

* Thu Apr 21 2022 Michel Alexandre Salim <salimma@fedoraproject.org> - 0.0.18-3
- Rebuild for libkdumpfile 0.4.1

* Sun Mar 06 2022 Davide Cavalca <dcavalca@fedoraproject.org> - 0.0.18-2
- Backport fix for armv7hl

* Sun Mar 06 2022 Davide Cavalca <dcavalca@fedoraproject.org> - 0.0.18-1
- Update to 0.0.18; Fixes: RHBZ#2060295, RHBZ#2046872

* Fri Jan 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.0.16-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Thu Dec 09 2021 Omar Sandoval <osandov@osandov.com> - 0.0.16-1
- Update to 0.0.16

* Thu Dec 09 2021 Omar Sandoval <osandov@osandov.com> - 0.0.15-1
- Update to 0.0.15

* Tue Oct 26 2021 Davide Cavalca <dcavalca@fedoraproject.org> - 0.0.14-2
- Add support for building from git snapshots for packit

* Thu Aug 12 2021 Davide Cavalca <dcavalca@fedoraproject.org> - 0.0.14-1
- Update to 0.0.14; Fixes: RHBZ#1993354

* Thu Aug 12 2021 Davide Cavalca <dcavalca@fedoraproject.org> - 0.0.13-6
- Update descriptions

* Tue Jul 27 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.0.13-3
- Second attempt - Rebuilt for
  https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Tue Jun  8 2021 Davide Cavalca <dcavalca@fedoraproject.org> - 0.0.13-2
- Backport fix for s390x and drop the ExcludeArch

* Tue Jun  8 2021 Davide Cavalca <dcavalca@fedoraproject.org> - 0.0.13-1
- Update to 0.0.13
- Drop no longer needed ExcludeArch for armv7hl and i686

* Fri Jun 04 2021 Python Maint <python-maint@redhat.com> - 0.0.11-3
- Rebuilt for Python 3.10

* Tue Apr  6 2021 Davide Cavalca <dcavalca@fedoraproject.org> - 0.0.11-2
- Make doc subpackage noarch
- Add license file

* Tue Apr  6 2021 Davide Cavalca <dcavalca@fedoraproject.org> - 0.0.11-1
- Initial package.

